=== debian/changelog ===
cppad (2021.00.00.8-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 27 Sep 2021 13:38:29 +0100

cppad (2021.00.00.7-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 17 Aug 2021 17:43:28 +0100
