=== debian/watch ===
# See uscan(1) for format
version=4

https://github.com/coin-or/CppAD/releases \
 .*/(\d\d\d\d)(\d\d)(\d\d)\.(\d+)\.tar\.gz
